/*
 * Toshiba_S1_Irda_enabler
 */

#define MY_VERSION	"0.01"

#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/types.h>
#include <linux/proc_fs.h>

#include <acpi/acpi.h>
#include <acpi/acresrc.h>
#include <acpi/actypes.h>

MODULE_AUTHOR("Holger Nelson");
MODULE_DESCRIPTION("Toshiba Tecra S1 IrDA-Enabler");
MODULE_LICENSE("GPL");

#define MY_LOGPREFIX "toshiba_s1_irda_enabler: "
#define MY_ERR KERN_ERR MY_LOGPREFIX
#define MY_NOTICE KERN_NOTICE MY_LOGPREFIX
#define MY_INFO KERN_INFO MY_LOGPREFIX

/* static void __init printres(struct acpi_resource *res) {
        printk(MY_INFO "Resource, length=%u, id=%u\n",res->length,res->id);
	switch (res->id) {
		case ACPI_RSTYPE_IO:
			printk(MY_INFO "IO: %x,%x,%u\n", 
				res->data.io.min_base_address, 
				res->data.io.max_base_address, 
				res->data.io.range_length);
			break;
		case ACPI_RSTYPE_FIXED_IO:
			printk(MY_INFO "Fixed IO: %x,%u\n", 
				res->data.fixed_io.base_address, 
				res->data.fixed_io.range_length);
			break;
		case ACPI_RSTYPE_IRQ:
			printk(MY_INFO "IRQ: %u\n", 
				res->data.irq.interrupts[0]);
			break;
		case ACPI_RSTYPE_DMA:
			printk (MY_INFO "DMA: %u\n", 
				res->data.dma.channels[0]);
			break;
	}
} */
			

static int __init
toshiba_acpi_init(void)
{
	acpi_status status = AE_OK;
	char *deviceName="\\_SB.PCI0.LPCB.SIOD.FIR";
	unsigned char myres[1024];
	acpi_handle handle;
/*	int x; int y;*/
	struct acpi_buffer buffer;
	struct acpi_resource *resource;

	printk(MY_INFO "Toshiba Tecra S1 IrDA-Enabler %s\n",
		MY_VERSION);
		

/*	buffer.length=4096;
	buffer.pointer=kmalloc(buffer.length,GFP_KERNEL); */

	status = acpi_get_handle(0, (char*)deviceName, &handle);
	if (status) {
		printk(MY_INFO "%s not found\n", deviceName);
		return -ENODEV;
	}

/*	printk(MY_INFO "_PRS:\n");
	status=acpi_get_possible_resources(handle,&buffer);
	if (status) printk(MY_INFO "_PRS failed, %x\n",status);
	
	for(resource=(struct acpi_resource *)buffer.pointer,x=0;
		(resource->id!=7)&&x<100;
		resource=(struct acpi_resource*)((char*) resource + resource->length),x++) 
		printres(resource);

	printk(MY_INFO "_CRS:\n");
	status=acpi_get_current_resources(handle,&buffer);
	
	if (status) printk(MY_INFO "_CRS failed, %x\n",status);
	
	for(resource=(struct acpi_resource *)buffer.pointer,x=0;
		x<6;resource=(struct acpi_resource*)((char*) resource + resource->length),x++)
		printres(resource);

	kfree(buffer.pointer); */

	resource=(struct acpi_resource *)myres;
	
	resource->id=ACPI_RSTYPE_IO;
	resource->data.io.min_base_address=0x2f8;
	resource->data.io.max_base_address=0x2f8;
	resource->data.io.io_decode=ACPI_DECODE_16;
	resource->data.io.alignment=0;
	resource->data.io.range_length=8;
	resource->length=ACPI_SIZEOF_RESOURCE(struct acpi_resource_io);
/*	printk(MY_INFO "length: %x\n",resource->length); */
	resource=(struct acpi_resource*)((char*) resource + resource->length);
/*	printk(MY_INFO "%x\n", resource); */
	resource->id=ACPI_RSTYPE_IRQ;
	resource->data.irq.edge_level=ACPI_EDGE_SENSITIVE;
	resource->data.irq.active_high_low=ACPI_ACTIVE_HIGH;
	resource->data.irq.shared_exclusive=ACPI_EXCLUSIVE;
	resource->data.irq.number_of_interrupts=1;
	resource->data.irq.interrupts[0]=3;
	resource->length=ACPI_SIZEOF_RESOURCE(struct acpi_resource_irq);
/*	printk(MY_INFO "length: %x\n",resource->length); */
	resource=(struct acpi_resource*)((char*) resource + resource->length);
/*	printk(MY_INFO "%x\n", resource); */
	resource->id=ACPI_RSTYPE_DMA;
	resource->data.dma.type=ACPI_COMPATIBILITY;
	resource->data.dma.bus_master=ACPI_NOT_BUS_MASTER;
	resource->data.dma.transfer=ACPI_TRANSFER_8;
	resource->data.dma.number_of_channels=1;
	resource->data.dma.channels[0]=1;
	resource->length=ACPI_SIZEOF_RESOURCE(struct acpi_resource_dma);
/*	printk(MY_INFO "length: %x\n",resource->length); */
	resource=(struct acpi_resource*)((char*) resource + resource->length);
/*	printk(MY_INFO "%x\n", resource); */
	resource->id=ACPI_RSTYPE_IO;
	resource->data.io.min_base_address=0x130;
	resource->data.io.max_base_address=0x130;
	resource->data.io.range_length=8;
	resource->data.io.io_decode=ACPI_DECODE_16;
	resource->data.io.alignment=0;
	resource->length=ACPI_SIZEOF_RESOURCE(struct acpi_resource_io);
/*	printk(MY_INFO "length: %x\n",resource->length); */
	resource=(struct acpi_resource*)((char*) resource + resource->length);
/*	printk(MY_INFO "%x\n", resource); */
	resource->id=ACPI_RSTYPE_END_TAG;
	resource->length=0;
/*	printk(MY_INFO "%x\n", resource); */
	buffer.length=8+(unsigned int)resource - (unsigned int)&myres;
	buffer.pointer=&myres;

/*	for(x=0;x<16;x++) {
	  printk(MY_INFO);
	  for(y=0;y<16;y++) printk("%02x ",myres[x*16+y]);
	  printk(KERN_INFO "\n");
	}

	resource=(struct acpi_resource*)&myres;
	printres(resource);
	resource=(struct acpi_resource*)((char*) resource + resource->length);
	printres(resource);
	resource=(struct acpi_resource*)((char*) resource + resource->length);
	printres(resource);
	resource=(struct acpi_resource*)((char*) resource + resource->length);
	printres(resource);
	resource=(struct acpi_resource*)((char*) resource + resource->length);
	printres(resource);
	resource=(struct acpi_resource*)((char*) resource + resource->length);
	printres(resource);
	resource=(struct acpi_resource*)((char*) resource + resource->length); */
	

	status = acpi_set_current_resources(handle,&buffer);
	printk(MY_INFO "status: %x\n",status);

/*	return (ACPI_SUCCESS(status)) ? 0 : -ENODEV;*/
	return -ENODEV;
}

static void __exit
toshiba_acpi_exit(void)
{
	return;
}

module_init(toshiba_acpi_init);
module_exit(toshiba_acpi_exit);
